/* vim:set et sw=2 cin cino=t0,f0,(0,{s,>2s,n-s,^-s,e2s: */
/*
 * Copyright © 2016 Collabora Ltd.
 *
 * SPDX-License-Identifier: MPL-2.0
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <glib.h>
#include <gio/gio.h>


/*
 * Declaration of the org.freedesktop.DBus.ObjectManager D-Bus interface.
 *
 * See: https://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager
 */

static const GDBusArgInfo object_manager_interface_arg_objpath_interfaces_and_properties =
{
  -1,  /* ref count */
  (gchar *) "objpath_interfaces_and_properties",
  (gchar *) "a{oa{sa{sv}}}",
  NULL
};

static const GDBusArgInfo object_manager_interface_arg_object_path =
{
  -1,  /* ref count */
  (gchar *) "object_path",
  (gchar *) "o",
  NULL
};

static const GDBusArgInfo object_manager_interface_arg_interfaces_and_properties =
{
  -1,  /* ref count */
  (gchar *) "interfaces_and_properties",
  (gchar *) "a{sa{sv}}",
  NULL
};

static const GDBusArgInfo object_manager_interface_arg_interfaces =
{
  -1,  /* ref count */
  (gchar *) "interfaces",
  (gchar *) "as",
  NULL
};

static const GDBusArgInfo *object_manager_interface_get_managed_objects_out_args[] =
{
  &object_manager_interface_arg_objpath_interfaces_and_properties,
  NULL,
};
static const GDBusMethodInfo object_manager_interface_get_managed_objects =
{
  -1,  /* ref count */
  (gchar *) "GetManagedObjects",
  NULL,  /* no in args */
  (GDBusArgInfo **) object_manager_interface_get_managed_objects_out_args,
  NULL,  /* annotations */
};

static const GDBusMethodInfo *object_manager_interface_methods[] =
{
  &object_manager_interface_get_managed_objects,
  NULL,
};

static const GDBusArgInfo *object_manager_interface_interfaces_added_args[] =
{
  &object_manager_interface_arg_object_path,
  &object_manager_interface_arg_interfaces_and_properties,
  NULL,
};
static const GDBusSignalInfo object_manager_interface_interfaces_added =
{
  -1,  /* ref count */
  (gchar *) "InterfacesAdded",
  (GDBusArgInfo **) object_manager_interface_interfaces_added_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *object_manager_interface_interfaces_removed_args[] =
{
  &object_manager_interface_arg_object_path,
  &object_manager_interface_arg_interfaces,
  NULL,
};
static const GDBusSignalInfo object_manager_interface_interfaces_removed =
{
  -1,  /* ref count */
  (gchar *) "InterfacesRemoved",
  (GDBusArgInfo **) object_manager_interface_interfaces_removed_args,
  NULL,  /* annotations */
};

static const GDBusSignalInfo *object_manager_interface_signals[] =
{
  &object_manager_interface_interfaces_added,
  &object_manager_interface_interfaces_removed,
  NULL,
};

static const GDBusInterfaceInfo object_manager_interface =
{
  -1,  /* ref count */
  (gchar *) "org.freedesktop.DBus.ObjectManager",
  (GDBusMethodInfo **) object_manager_interface_methods,
  (GDBusSignalInfo **) object_manager_interface_signals,
  NULL,  /* no properties */
  NULL,  /* no annotations */
};
